﻿
// ---------------------- top of file DesignPnl.cs ----------------------
using System.Drawing;
using System.Windows.Forms;
public class DesignPanel : Panel { 
    public const float Zoom = 2;   
    public float SAmm { get{ return float.Parse(par.controlPanel2.comboSA.Text); } } // in mm 
    public float STmm { get{ return float.Parse(par.controlPanel2.comboST.Text); } } // in mm  
    public float SApixel { get{ return SAmm*Zoom; } } // in mm 
    public float SWpixel {get {   
            if (!par.menu_Mode_Vertical.Checked) {
                return SAmm*Zoom; 
            } else {
                return STmm*Zoom; } } } 
    public float SHpixel {get {   
            if (!par.menu_Mode_Vertical.Checked) {
                return STmm*Zoom; 
            } else {
                return SAmm*Zoom; } } } 
    public float whiteWmm {get { 
            if (!par.menu_Mode_Vertical.Checked) {
                return par.getNA() * SAmm; 
            } else if (par.menu_Mode_Bag.Checked) {
                return (par.getNT()+1) * STmm; 
			} else { 
                return par.getNT() * STmm; 
            } } } 
    public float whiteHmm {get { 
            if (!par.menu_Mode_Vertical.Checked) {
                return par.getNT() * STmm; 
            } else {
                return par.getNA() * SAmm; 
            } } } 
    public float whiteWpixel {get {
            return whiteWmm * Zoom; } } 
    public float whiteHpixel {get {
            return whiteHmm * Zoom; } } 
    private float _Lmm = 31, _Tmm = 25; 
    public float Lmm{  
        get { 
            return _Lmm; } 　
        set { 
            _Lmm=value; } 
    } 
    public float Tmm{ 
        get { return _Tmm; } 
        set { _Tmm=value; } 
    }
    public float Lpixel {get {
            return Lmm * Zoom ; } } 
    public float Tpixel {get {
            return  Tmm * Zoom ; } } 
    // =============================================================================  
	static Pen myBlackPen = new Pen(Color.Black, 1); 
    public int shiftxzoomed, shiftyzoomed; 
	static System.Drawing.Brush myWhiteBrush=new SolidBrush(Color.White), 
                myBlackBrush=new SolidBrush(Color.Black),  
                myLightGrayBrush=new SolidBrush(Color.LightGray); 
	static System.Drawing.Font myFont12=new System.Drawing.Font("MS UI Gothic", 12);
	static System.Drawing.Font myFont10=new System.Drawing.Font("MS UI Gothic", 10);
    private WhitePanel _whitepanel;
    public WhitePanel whitepanel {
        get {
            return _whitepanel;  
            } 
        set {
            _whitepanel = value; 
        } } // ============================================== 
	public MyForm par; 
	public DesignPanel(MyForm partf) {
		par = partf; 
        timer.Tick +=(o,e) =>{ 
            if (sawf > 0) {  
                Refresh();    
                sawf--;
                if (sawf == 0) {
                    timer.Stop(); 
                }  
            } 
        };
        timer.Interval = 200; 
    } // ========================================================================= 
	public void create() { 		
        whitepanel = new WhitePanel(this);  
        this.BackColor= Color.White; 
		this.DoubleBuffered = true; 
    } // ========================================================================= 
	Bitmap bmbasez; 
	protected override void OnSizeChanged(System.EventArgs e) {
		onsizechanged(); 
    } // =========================================================================  
	public void onsizechanged() {
		float Zoom = 2f; // 		float.Parse(par.controllerPanel.combozoom.SelectedItem.ToString());  
		bmbasez = new Bitmap((int)(par.paperwidthmm*Zoom)+1, (int)(par.paperheightmm*Zoom)+1);
		this.Width = bmbasez.Width; this.Height = bmbasez.Height;
		Graphics g = bmbasez.getGraphics(); 
		float wsquare = 10 * Zoom; 
		for (int i=0; i<1000; i++) {
			float ii = i * wsquare; 
			for (int j=0; j<1000; j++) {
				float jj = j * wsquare, k = i + j; 
				if (k%2 == 0) {
					g.FillRectangle(myLightGrayBrush, ii, jj, wsquare, wsquare); 
				} 
				if (j > this.Height) { break; } 
			} 
			if (i > this.Width) { break; } 
		} 
		Invalidate(); 
    } // =========================================================================  
	public bool waitingselectionz = false;
	public Point selectionbegin, selectionend;
	public Point selectionabsolutebegin, selectionabsoluteend;
	protected override void OnPaint(PaintEventArgs args) { // on Form drawing area !!!  
        Graphics g = args.Graphics; 
		// ############################################################## 
		g.TranslateTransform( -shiftxzoomed, -shiftyzoomed); 
		paintPage(g); 
    } // ========================================================================= 
	int whiteEpixel, whiteSpixel, bw; 
	protected void paintPage(Graphics g) { // on Page !!! in page designer 
		if (whitepanel == null) { return; } 
		float Zoom = 2; 
		g.DrawImage(bmbasez,0,0); 
		float pwnaiive = par.paperwidthmm, phnaiive = par.paperheightmm; // naiive means in mm 
		float dxnaiive = Lmm, rightxnaiive=pwnaiive-Lmm-whiteWmm;
		float dynaiive = Tmm, bottomynaiive = phnaiive - dynaiive - whiteHmm; //  whnaiive; 
		int dxzoomed = (int)(dxnaiive*Zoom), dyzoomed = (int)(dynaiive*Zoom), 
			wwzoomed = (int)(whiteWmm*Zoom), whzoomed = (int)(whiteHmm*Zoom),
			cx = dxzoomed + wwzoomed / 2, cy = dyzoomed + whzoomed / 2, // center  zoomed
			pwzoomed=(int)(pwnaiive*Zoom), phzoomed=(int)(phnaiive*Zoom); 
		whiteEpixel = (int)(Lpixel + whiteWpixel); whiteSpixel = (int)(Tpixel + whiteHpixel);
		int bw2 = (int)(SApixel); 
		bw = (int)(SApixel * 0.5f); 
		if (!par.menu_Mode_Vertical.Checked) { 
			float f = whiteWpixel; 
			g.FillRectangle(whitebrush, Lpixel-bw, Tpixel, whiteWpixel+bw2, whiteHpixel); 
		} else { 
			g.FillRectangle(whitebrush, Lpixel, Tpixel-bw, whiteWpixel, whiteHpixel+bw2); } 
		// ===         dx * 0.25401   was orig !!! 
		string strW = dxnaiive.ToString("f1"), strE = rightxnaiive.ToString("f1"), 
			strN = dynaiive.ToString("f1"), strS = bottomynaiive.ToString("f1"); // deci_mm 
		drawlineRenderer2(g, strW,"mm", myFont12, dxzoomed/2-10, cy+4); 
		drawlineRenderer(g, strN+"mm", myFont12, cx+6, dyzoomed/2-7);
		drawlineRenderer2(g, strE, "mm", myFont12, (pwzoomed+wwzoomed+dxzoomed)/2-10, cy+4); 
		drawlineRenderer(g, strS+"mm", myFont12, cx+6, (phzoomed+whzoomed+dyzoomed)/2-9);
		string strWdt = whiteWmm.ToString("f1"), strHgt = whiteHmm.ToString("f1");
		drawlineRenderer(g, strWdt+" mm",myFont12, cx-70, (int)(Tpixel)-(int)(4*Zoom)-18); 
        if (!par.menu_Mode_Vertical.Checked) {  
			drawlineRenderer2(g, strHgt," mm", myFont12, (int)(Lpixel)-(int)(4*Zoom)-40, cy-80); 
		} else {
			drawlineRenderer2(g, strHgt," mm", myFont12, whiteEpixel+(int)(4*Zoom)+8, cy-80); 
		} 

		g.DrawLine(myBlackPen, 0, cy, (int)(Lpixel), cy);
		g.DrawLine(myBlackPen, whiteEpixel, cy, pwzoomed, cy);
		g.DrawLine(myBlackPen, cx, 0, cx, (int)(Tpixel)); 
		g.DrawLine(myBlackPen, cx, whiteSpixel, cx, phzoomed); 
		// ##############################   
		doPageEssential(g); // pagetop origin    on page 
		
		g.DrawLine(myBlackPen, (int)(Lpixel),(int)(Tpixel)-4*Zoom,whiteEpixel,(int)(Tpixel)-4*Zoom); // 横  
        if (!par.menu_Mode_Vertical.Checked) { 
			g.DrawLine(myBlackPen, (int)(Lpixel)-4*Zoom,(int)(Tpixel),(int)(Lpixel)-4*Zoom,whiteSpixel); // 縦  
		} else {
			g.DrawLine(myBlackPen, whiteEpixel+4*Zoom,(int)(Tpixel),whiteEpixel+4*Zoom,whiteSpixel); // 縦  
		} 

		Pen myRedPen =new Pen(Color.Red, 1); 
		g.DrawLine(myRedPen, (int)(Lpixel),0,(int)(Lpixel),phzoomed); // 縦２ 
		g.DrawLine(myRedPen, whiteEpixel,0,whiteEpixel,phzoomed); // 縦３
		g.DrawLine(myRedPen, 0,(int)(Tpixel),pwzoomed,(int)(Tpixel)); // 横２　　was 1900 
		g.DrawLine(myRedPen, 0,whiteSpixel,pwzoomed,whiteSpixel); // 横３ 
        g.DrawLine(myRedPen, 0,0,0,phzoomed); // 縦左端 
        g.DrawLine(myRedPen, pwzoomed,0,pwzoomed,phzoomed); // 縦４
        g.DrawLine(myRedPen, 0,0,pwzoomed,0); // 横トップ
        g.DrawLine(myRedPen, 0,phzoomed,pwzoomed,phzoomed); // 横４  
        g.DrawString(par.PPSZCIz.PaperName+",  "+par.textpanel.fontname, myFont10, myBlackBrush, 8, 6); // strfmt is added !!!  
		// 
		g.TranslateTransform(Lpixel, Tpixel);
		int p = int.Parse(par.controlPanel2.comboP.SelectedItem.ToString());
		int NT = par.getNT(), NA = par.getNA(); 
		if (p==0) {  
			if (!par.menu_Mode_Vertical.Checked) { 
				for(int i = 1; i < NA; i++) {
					float x=i*SWpixel;    
					g.DrawLine(bluepen, x, 0, x, whiteHpixel); // 縦
				} 
				for (int j=1; j<NT; j++) {
					float y =j*SHpixel; 
					g.DrawLine(bluepen, 0, y, whiteWpixel, y); // 横 
				}  
			} else { 
				for(int i = 1; i < NT; i++) {
					float x=i*SWpixel;    
					g.DrawLine(bluepen, x, 0, x, whiteHpixel); // 縦
				} 
				for (int j=1; j<NA; j++) {
					float y =j*SHpixel; 
					g.DrawLine(bluepen, 0, y, whiteWpixel, y); // 横 
				} 
			} 
		} 
		

		if (p >= 1) {
			par.textpanel.setfontdesign();
			if (!par.menu_Mode_Vertical.Checked) { 
				par.textpanel.DesignHoriz(g, p, 2); 
			} else { 
				par.textpanel.DesignVerti(g, p, 2, "design"); 
			} 
		} 
    } // =========================================================================  
    void drawlineRenderer(Graphics g, string str, Font font, int x, int y) {  
        StringFormat fmttypo=StringFormat.GenericTypographic; // フォントのI幅が正確に求められる！！！ 
        SizeF sizef=TextRenderer.MeasureText(str, font); 
        g.FillRectangle(myWhiteBrush, x, y, sizef.Width-5, sizef.Height);  
        g.DrawString(str, font, myBlackBrush, new Point(x, y), fmttypo); // strfmt is added !!! 
    } // ==================================================================================================== 
    void drawlineRenderer2(Graphics g, string str1, string str2, Font font, int x, int y) {  
        StringFormat fmttypo=StringFormat.GenericTypographic; // フォントのI幅が正確に求められる！！！ 
        SizeF sizef=TextRenderer.MeasureText(str1, font); 
        Rectangle rect=new Rectangle(x, y, (int)sizef.Width-5, (int)sizef.Height*2);  
        g.FillRectangle(myWhiteBrush, rect);   
        g.DrawString(str1+str2, font, myBlackBrush, rect, fmttypo); // strfmt is added !!! 
    } // ==================================================================================================== 
    public Brush brush=new SolidBrush(Color.Orange);
    public Brush myOrangeBrush=new SolidBrush(Color.Orange);
	public Brush skeletonbrush = new SolidBrush(Color.FromArgb(1, 255, 255, 255)); 
	public Brush whitebrush = new SolidBrush(Color.White); 
	public Brush bluebrush = new SolidBrush(Color.FromArgb(255,10,150,255)); 
	public Pen bluepen = new Pen(Color.FromArgb(255,10,150,255)); 
	public void doPageEssential(Graphics g) { // on page 
        int x0 = (int)(Lpixel), y0=(int)(Tpixel); // white space on page 
		g.TranslateTransform(x0, y0);  
		whitepanel.doOnWhite(g); // on whitespace 
		g.TranslateTransform(-x0, -y0); 
	} // ========================================================== 
	bool moving = false, inwhite=false;
	int Xprev, Yprev;
	float Lmmfirst, Tmmfirst;
    protected override void OnMouseDown(MouseEventArgs e) {
		moving = true; 
		if (this.Cursor==Cursors.SizeWE) {
			Lmmfirst = Lmm; 
			Xprev = Cursor.Position.X; 
		} else if (this.Cursor == Cursors.SizeNS) { 
			Tmmfirst = Tmm; 
			Yprev = Cursor.Position.Y;
		} else if (this.Cursor == Cursors.SizeAll) { 
			Lmmfirst = Lmm;
			Tmmfirst = Tmm; 
			Xprev = Cursor.Position.X; 
			Yprev = Cursor.Position.Y;
		} else {
			moving = false;
			inwhite = false; 
			MessageBox.Show("編集は「モード：デザイン／編集」チェック解除状態で可能です！！！"); } 
	} // ======================================================================  
    protected override void OnMouseMove(MouseEventArgs e) { 
		whitepanel.OnMouseMove(e);  
		if (inwhite) { 
			whitepanel.OnMouseMove(e); 
		} else if (moving) { 
			int xnow = Cursor.Position.X, ynow = Cursor.Position.Y;
			bool needref = false; 
			if (this.Cursor != Cursors.SizeNS && xnow != Xprev) {  
				int dx = xnow - Xprev; 
				Xprev = xnow;
				Lmm += dx/30f; 
				needref = true; 
			} 
			if (this.Cursor != Cursors.SizeWE && ynow != Yprev) {  
				int dy = ynow - Yprev;
				Yprev = ynow; 
				Tmm += dy/30f; 
				needref = true; 
			} 
			if (needref) { 
				Refresh(); }  
		} else if (!par.menu_Mode_Vertical.Checked) { 
			if (e.Y < (int)(Tpixel) || e.Y > whiteSpixel) {
				if (e.X < (int)(Lpixel) || e.X > whiteEpixel) { 
					this.Cursor = Cursors.SizeAll; 
				} else {
					this.Cursor = Cursors.SizeNS; 
				}  
			} else {
				if (e.X < (int)(Lpixel)-bw || e.X > whiteEpixel+bw) { 
					this.Cursor = Cursors.SizeWE; 
				} else {
					this.Cursor = Cursors.Default; 
				}  
			}  
		} else {
			if (e.X < (int)(Lpixel) || e.X > whiteEpixel) { 
				if (e.Y < (int)(Tpixel) || e.Y > whiteSpixel) {
					this.Cursor = Cursors.SizeAll; 
				} else {
					this.Cursor = Cursors.SizeWE; 
				} 
			} else {
				if (e.Y < (int)(Tpixel)-bw || e.Y > whiteSpixel+bw) {
					this.Cursor = Cursors.SizeNS; 
				} else {
					this.Cursor = Cursors.Default; 
				} 
			}  
		} 
	} // ======================================================================  
    protected override void OnMouseUp(MouseEventArgs e) {
		if (inwhite) { 
			whitepanel.OnMouseUp(e);  
			inwhite = false; 
		} else if (moving) {  
			moving = false; 
			sawf = 2; 
		} 
	} // ======================================================================  
    Timer timer = new Timer();
    int sawf = 0;
	// ######################### inner classes ################################### 
	public  class WhitePanel : Panel { 
		bool moving = false; 
		public Rectangle rect; 
		int mx, my;
		public Brush homebrush = new SolidBrush(Color.FromArgb(85, 255, 155, 155));  
		DesignPanel panele; 
		public WhitePanel(DesignPanel paneletf) {
			panele = paneletf;
			float _Zoom = 2f; //
			float wwnaiive= panele.whiteWmm ,  whnaiive = panele.whiteHmm;
			this.Size = new Size((int)(wwnaiive * _Zoom), (int)(whnaiive * _Zoom)); 
			int iii = Size.Width; 
			timer.Tick +=(o,e) =>{ 
				if (sawf > 0) {  
					panele.Refresh();    
					sawf--;
					if (sawf == 0) {
						timer.Stop(); 
					}  
				} 
			};
			timer.Interval = 200; 
		} // ================================================================= 
		Timer timer = new Timer();
		int sawf = 0; 
		public void OnMouseMove(MouseEventArgs e) { // === home means small panel 
			if (!moving) { return; } 
		} // ================================================================= 
		public void OnMouseUp(MouseEventArgs e) { // === home means small panel 
			if (!moving) { return; } 
			moving = false; 
			sawf = 2; 
		} // =================================================================  
		public virtual void doOnWhite(Graphics g) {
			Size s = this.Size;
			int xx = s.Width, yy = s.Height;  
		}  
	} // #####################################################################  
} // #############################################################################  
// ---------------------- bottom of file DesignPnl.cs ----------------------
